

### Class: rexx

> The main class of X-Core AddOn inherited from class rex.

| Visibility | Function |
|:-----------|:---------|
| public static | <strong>addLangPreset(</strong><em>string</em> <strong>$originalName</strong>, <em>string</em> <strong>$code</strong>, <em>string</em> <strong>$regionCode</strong>, <em>string</em> <strong>$urlSlug</strong>, <em>string</em> <strong>$hreflang</strong>, <em>string</em> <strong>$dir</strong>, <em>string[]</em> <strong>$specialChars</strong>, <em>string[]</em> <strong>$specialCharsRewrite</strong>)</strong> : <em>void</em><br /><em>Adds a custom lang preset. Can be used in boot.php of project addon to add a custom preset.</em> |
| public static | <strong>getAbsoluteFile(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns the absolute file with path of the given file starting from frontend path.</em> |
| public static | <strong>getAbsoluteImageFile(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns the absolute file with path of the given image of resource dir.</em> |
| public static | <strong>getAbsoluteMediaFile(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns the absolute file with path of the given media file of media dir.</em> |
| public static | <strong>getAbsolutePath(</strong><em>string</em> <strong>$path</strong>)</strong> : <em>string</em><br /><em>Returns the absolute path of the given path starting from frontend path.</em> |
| public static | <strong>getArrayFromRexValue(</strong><em>string</em> <strong>$value</strong>)</strong> : <em>array[]</em><br /><em>Returns an array from a rex value. Wrapper for rex_var::toArray($value);</em> |
| public static | <strong>getArrayFromString(</strong><em>string</em> <strong>$string</strong>, <em>string</em> <strong>$delimiter=`','`</strong>, <em>bool</em> <strong>$trim=true</strong>)</strong> : <em>string</em><br /><em>Explodes and trims a string by given delimiter. Default delimeter is the comma char. Useful for REX_MEDIALIST[] /  REX_LINKLIST[] output.</em> |
| public static | <strong>getArticle(</strong><em>int</em> <strong>$articleId</strong>, <em>int</em> <strong>$clangId=null</strong>)</strong> : <em>\rex_article</em><br /><em>Returns the article object from given article id.</em> |
| public static | <strong>getArticleContent(</strong><em>int</em> <strong>$articleId</strong>, <em>int</em> <strong>$ctypeId=-1</strong>)</strong> : <em>string</em><br /><em>Returns the article content for the given article id.</em> |
| public static | <strong>getArticleLink(</strong><em>int</em> <strong>$articleId</strong>)</strong> : <em>string</em><br /><em>Returns an link tag with url and name from specified article id.</em> |
| public static | <strong>getArticleName(</strong><em>int</em> <strong>$articleId</strong>)</strong> : <em>string</em><br /><em>Returns the article name from specified article id.</em> |
| public static | <strong>getBackendUrl(</strong><em>array</em> <strong>$params=array()</strong>, <em>bool</em> <strong>$escape=true</strong>)</strong> : <em>string</em><br /><em>Returns backend url. Same as rex_url::backendController();</em> |
| public static | <strong>getBaseUrl()</strong> : <em>string</em><br /><em>Returns the base url of site. Same as rexx::getServer().</em> |
| public static | <strong>getCSSDir()</strong> : <em>string</em><br /><em>Returns the css dir specified in the config of addon.</em> |
| public static | <strong>getCSSFile(</strong><em>string</em> <strong>$file</strong>, <em>array/string[]</em> <strong>$vars=array()</strong>)</strong> : <em>string</em><br /><em>Returns css file with path of resource dir and version string. If less or scss file is given it will be compiled.</em> |
| public static | <strong>getCanonicalUrl()</strong> : <em>string</em><br /><em>Returns the current canonical url.</em> |
| public static | <strong>getCategory(</strong><em>int</em> <strong>$id</strong>, <em>int</em> <strong>$clangId=null</strong>)</strong> : <em>\rex_category</em><br /><em>Returns the category by id.</em> |
| public static | <strong>getCombinedCSSFile(</strong><em>string</em> <strong>$combinedFile</strong>, <em>string[]</em> <strong>$sourceFiles</strong>)</strong> : <em>string</em><br /><em>Combines multiple css files and returns file with path of resource dir and version string. Also compiles scss and less if necessary.</em> |
| public static | <strong>getCombinedJSFile(</strong><em>string</em> <strong>$combinedFile</strong>, <em>string[]</em> <strong>$sourceFiles</strong>)</strong> : <em>string</em><br /><em>Combines multiple js files and returns file with path of resource dir and version string.</em> |
| public static | <strong>getCurrentArticle()</strong> : <em>\rex_article</em><br /><em>Returns the current article.</em> |
| public static | <strong>getCurrentArticleAttribute(</strong><em>string[]</em> <strong>$attributeValues</strong>, <em>string</em> <strong>$attributeType=`'id'`</strong>)</strong> : <em>string</em><br /><em>Gets html attribute based on given attribute values and current article id. Example param: $attributeValues = [ '1' => 'home' ];</em> |
| public static | <strong>getCurrentArticleContent(</strong><em>int</em> <strong>$ctypeId=-1</strong>)</strong> : <em>string</em><br /><em>Returns the content of the current article.</em> |
| public static | <strong>getCurrentArticleId()</strong> : <em>int</em><br /><em>Returns the id of current article.</em> |
| public static | <strong>getCurrentArticleName()</strong> : <em>string</em><br /><em>Returns the name of current article.</em> |
| public static | <strong>getCurrentCategory()</strong> : <em>\rex_category</em><br /><em>Returns the current category.</em> |
| public static | <strong>getCurrentCategoryId()</strong> : <em>int</em><br /><em>Returns the current category id.</em> |
| public static | <strong>getCurrentClang()</strong> : <em>\rex_clang</em><br /><em>Returns the current clang. Same as rex_clang::getCurrent().</em> |
| public static | <strong>getCurrentClangId()</strong> : <em>int</em><br /><em>Returns the current clang id. Same as rex_clang::getCurrentId().</em> |
| public static | <strong>getCurrentParentCategory()</strong> : <em>\rex_category</em><br /><em>Returns the parent category of current category.</em> |
| public static | <strong>getCurrentParentCategoryId()</strong> : <em>int</em><br /><em>Returns the parent id of current category.</em> |
| public static | <strong>getDefaultGlobalValue(</strong><em>string</em> <strong>$field</strong>, <em>bool/int</em> <strong>$allowEmpty=true</strong>)</strong> : <em>string</em><br /><em>Returns default global value from global settings addon. If value is empty output will be empty. Same as rex_global_settings::getDefaultValue();</em> |
| public static | <strong>getDefaultString(</strong><em>string</em> <strong>$field</strong>, <em>bool/int</em> <strong>$allowEmpty=false</strong>)</strong> : <em>string</em><br /><em>Returns default global string value from global settings addon. If value is empty output will be a placeholder. Same as rex_global_settings::getDefaultString();</em> |
| public static | <strong>getDescription()</strong> : <em>string</em><br /><em>Returns the current description for the description tag.</em> |
| public static | <strong>getDownloadFile(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns a download url for the given file. Browser will prompt user to download file with this.</em> |
| public static | <strong>getEmailLink(</strong><em>string</em> <strong>$email</strong>)</strong> : <em>string</em><br /><em>Returns the email link with mailto: at the beginning.</em> |
| public static | <strong>getFavIconDir()</strong> : <em>string</em><br /><em>Returns the favicon dir specified in the config of addon.</em> |
| public static | <strong>getFavIconFile(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns favicon file with path of resource dir.</em> |
| public static | <strong>getFullMediaUrl(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns a full media url starting with http://.</em> |
| public static | <strong>getFullUrl(</strong><em>int</em> <strong>$id=null</strong>, <em>int</em> <strong>$clang=null</strong>, <em>array/string[]</em> <strong>$params=array()</strong>, <em>string</em> <strong>$separator=`'&amp;'`</strong>)</strong> : <em>string</em><br /><em>Returns a full url starting with http:// based on the params.</em> |
| public static | <strong>getGlobalJSVars(</strong><em>array/string[]</em> <strong>$jsVars=array()</strong>)</strong> : <em>string</em><br /><em>Converts global settings values to javascript variables. Example param: $jsVars = [ 'cmsSliderPause' => 'glob_slider_pause', 'cmsSliderSpeed' => 'glob_slider_speed', 'cmsOpenExternalLinksInNewWindow' => 'glob_external_link_new_window' ];</em> |
| public static | <strong>getGlobalValue(</strong><em>string</em> <strong>$field</strong>, <em>int</em> <strong>$clangId=null</strong>, <em>bool/int</em> <strong>$allowEmpty=true</strong>)</strong> : <em>string</em><br /><em>Returns global value from global settings addon. If value is empty output will be empty. Same as rex_global_settings::getValue();</em> |
| public static | <strong>getHtmlAttribute(</strong><em>string</em> <strong>$attribute</strong>, <em>string</em> <strong>$value</strong>)</strong> : <em>string</em><br /><em>Gives an attribute value pair for html usage. If $value is empty, an empty string will be returned.</em> |
| public static | <strong>getImageDir()</strong> : <em>string</em><br /><em>Returns the image dir specified in the config of addon.</em> |
| public static | <strong>getImageFile(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns image file with path of resource dir.</em> |
| public static | <strong>getJSCodeFromFile(</strong><em>string</em> <strong>$file</strong>, <em>bool</em> <strong>$simpleMinify=true</strong>)</strong> : <em>string</em><br /><em>Returns js code as sring from given file.</em> |
| public static | <strong>getJSDir()</strong> : <em>string</em><br /><em>Returns the js dir specified in the config of addon.</em> |
| public static | <strong>getJSFile(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns js file with path of resource dir and version string.</em> |
| public static | <strong>getKeywords()</strong> : <em>string</em><br /><em>Returns the current keywords for the keywords tag. At the moment "art_keywords" meta info field of article will be used (if present).</em> |
| public static | <strong>getLangCode(</strong><em>int</em> <strong>$clangId=null</strong>)</strong> : <em>string</em><br /><em>Returns the the current lang code.</em> |
| public static | <strong>getLangCount()</strong> : <em>int</em><br /><em>Returns number of langauges of the site.</em> |
| public static | <strong>getLangTags()</strong> : <em>string</em><br /><em>Returns the current hreflang Tags.</em> |
| public static | <strong>getLastUpdateDate(</strong><em>string</em> <strong>$format=`'d.m.Y'`</strong>)</strong> : <em>string</em><br /><em>Returns the last update date of site based on the last article update date. $format is the same param type as in date() function.</em> |
| public static | <strong>getManagedMediaFile(</strong><em>string</em> <strong>$mediaFile</strong>, <em>string</em> <strong>$mediaType</strong>, <em>bool</em> <strong>$validHtml=true</strong>)</strong> : <em>string</em><br /><em>Returns a seo friendly url for the media manager file.</em> |
| public static | <strong>getManagedMediaHeight(</strong><em>string</em> <strong>$mediaFile</strong>, <em>string</em> <strong>$mediaType</strong>)</strong> : <em>int</em><br /><em>Returns image height of media manager file base on media type.</em> |
| public static | <strong>getManagedMediaWidth(</strong><em>string</em> <strong>$mediaFile</strong>, <em>string</em> <strong>$mediaType</strong>)</strong> : <em>int</em><br /><em>Returns image width of media manager file base on media type.</em> |
| public static | <strong>getMedia(</strong><em>string</em> <strong>$filename</strong>)</strong> : <em>\rex_media</em><br /><em>Returns media object. Same as rex_media::get().</em> |
| public static | <strong>getMediaDir()</strong> : <em>\rex_media</em><br /><em>Returns media directory.</em> |
| public static | <strong>getMediaDirName()</strong> : <em>string</em><br /><em>Returns the pure media directory name.</em> |
| public static | <strong>getMediaFile(</strong><em>string</em> <strong>$file</strong>)</strong> : <em>string</em><br /><em>Returns given media file with media directory.</em> |
| public static | <strong>getMediaManagerFile(</strong><em>string</em> <strong>$mediaFile</strong>, <em>string</em> <strong>$mediaType</strong>, <em>bool</em> <strong>$validHtml=true</strong>)</strong> : <em>string</em><br /><em>Deprecated: use getManagedMediaFile().</em> |
| public static | <strong>getMediaTypeDescription(</strong><em>string</em> <strong>$mediaType</strong>)</strong> : <em>string</em><br /><em>Returns the description of the given mediatype.</em> |
| public static | <strong>getNotfoundArticleId()</strong> : <em>string</em><br /><em>Returns the notfound article id specified in system settings. Same as rex_article::getNotfoundArticleId().</em> |
| public static | <strong>getResourceFile(</strong><em>string</em> <strong>$fileWithPath</strong>)</strong> : <em>string</em><br /><em>Returns file with path of resource dir and version string. If less or scss file is given it will be compiled.</em> |
| public static | <strong>getRobotRules()</strong> : <em>string</em><br /><em>Returns the current robot rules for the robots tag.</em> |
| public static | <strong>getRootCategories(</strong><em>bool</em> <strong>$ignoreOfflines=false</strong>, <em>int</em> <strong>$clangId=null</strong>)</strong> : <em>\rex_category[]</em><br /><em>Returns the root categories.</em> |
| public static | <strong>getServerHost(</strong><em>bool</em> <strong>$removeWWW=false</strong>)</strong> : <em>string</em><br /><em>Returns the server url without http:// and can also remove www from host.</em> |
| public static | <strong>getServerSubDir()</strong> : <em>string</em><br /><em>Returns the subdir if redaxo is installed in subdir.</em> |
| public static | <strong>getServerUrl()</strong> : <em>string</em><br /><em>Returns the server url specified in system settings. Same as rexx::getServer().</em> |
| public static | <strong>getSiteName()</strong> : <em>string</em><br /><em>Returns the sitename. Same as rexx::getServerName().</em> |
| public static | <strong>getSiteStartArticleId()</strong> : <em>string</em><br /><em>Returns the site startarticle id specified in system settings. Same as rex_article::getSiteStartArticleId().</em> |
| public static | <strong>getSiteUrl()</strong> : <em>string</em><br /><em>Returns the url of the site start article = home of frontend.</em> |
| public static | <strong>getSliceStatus(</strong><em>int</em> <strong>$sliceId</strong>)</strong> : <em>int</em><br /><em>Returns the status of the slice. Works only if addon like blöcks is installed.</em> |
| public static | <strong>getString(</strong><em>string</em> <strong>$field</strong>, <em>int</em> <strong>$clangId=null</strong>, <em>bool/int</em> <strong>$allowEmpty=false</strong>)</strong> : <em>string</em><br /><em>Returns global string value from global settings addon. If value is empty output will be a placeholder. Same as rex_global_settings::getString();</em> |
| public static | <strong>getStrippedString(</strong><em>string</em> <strong>$string</strong>, <em>bool</em> <strong>$removeParagraphs=true</strong>)</strong> : <em>string</em><br /><em>Returns a string without p tags. Useful to remove p tags from editor output.</em> |
| public static | <strong>getTabbedForm(</strong><em>string</em> <strong>$form</strong>)</strong> : <em>string</em><br /><em>Converts a form with fieldsets into tabs :)</em> |
| public static | <strong>getTelLink(</strong><em>string</em> <strong>$phoneNumber</strong>, <em>bool</em> <strong>$convertPrefix=true</strong>, <em>string</em> <strong>$prefix=`'+'`</strong>, <em>string</em> <strong>$substitute=`'00'`</strong>)</strong> : <em>string</em><br /><em>Returns the phone number for use in link with tel: protocol. Strips whitespaces etc and converts + to 00.</em> |
| public static | <strong>getTitle(</strong><em>string</em> <strong>$siteName=`''`</strong>)</strong> : <em>string</em><br /><em>Returns title for title tag. If $siteName specified the default sitename will be ignored.</em> |
| public static | <strong>getTitleDelimiter()</strong> : <em>string</em><br /><em>Returns the title delimiter for the title tag.</em> |
| public static | <strong>getTitlePart()</strong> : <em>string</em><br /><em>Returns the current title part without sitename.</em> |
| public static | <strong>getTrackingCode()</strong> : <em>string</em><br /><em>Returns value from "tracking_code" field from global_settings addon.</em> |
| public static | <strong>getTrimmedUrl(</strong><em>int</em> <strong>$id=null</strong>, <em>int</em> <strong>$clang=null</strong>, <em>array/string[]</em> <strong>$params=array()</strong>, <em>string</em> <strong>$separator=`'&amp;'`</strong>)</strong> : <em>string</em><br /><em>Returns a relative url based on the params without url start slug, http etc.</em> |
| public static | <strong>getUrl(</strong><em>int</em> <strong>$id=null</strong>, <em>int</em> <strong>$clang=null</strong>, <em>array/string[]</em> <strong>$params=array()</strong>, <em>string</em> <strong>$separator=`'&amp;'`</strong>)</strong> : <em>string</em><br /><em>Returns a relative url based on the params. Same as rex_getUrl().</em> |
| public static | <strong>getUrlEnding()</strong> : <em>string</em><br /><em>Returns the url ending.</em> |
| public static | <strong>getUrlStart()</strong> : <em>string</em><br /><em>Returns the url start slug.</em> |
| public static | <strong>getUrlString(</strong><em>string</em> <strong>$string</strong>)</strong> : <em>string</em><br /><em>Returns a normalized string that can be used in urls and anchor names.</em> |
| public static | <strong>includeTemplate(</strong><em>int</em> <strong>$templateId</strong>)</strong> : <em>void</em><br /><em>Includes a template. Same as REX_TEMPLATE[].</em> |
| public static | <strong>init()</strong> : <em>void</em><br /><em>Initilizes the rexx class. X-Core calls this automatically.</em> |
| public static | <strong>isArticleOnline(</strong><em>int</em> <strong>$articleId</strong>)</strong> : <em>bool</em><br /><em>Returns true if article with given id is online.</em> |
| public static | <strong>isArticleSliceValid(</strong><em>\rex_article_slice</em> <strong>$slice</strong>)</strong> : <em>bool</em><br /><em>Returns true if given slice is valid. Same as rexx::isSliceValid();</em> |
| public static | <strong>isArticleValid(</strong><em>\rex_article</em> <strong>$article</strong>)</strong> : <em>bool</em><br /><em>Returns true if given article is valid.</em> |
| public static | <strong>isCategoryValid(</strong><em>\rex_category</em> <strong>$category</strong>)</strong> : <em>bool</em><br /><em>Returns true if given category is valid.</em> |
| public static | <strong>isCurrentArticleOnline()</strong> : <em>bool</em><br /><em>Returns true if current article is online.</em> |
| public static | <strong>isCurrentUrlValid()</strong> : <em>bool</em><br /><em>Checks if current url is available by the used rewriter. Must be called in PACKAGE_INCLUDED or later!</em> |
| public static | <strong>isEven(</strong><em>int</em> <strong>$number</strong>)</strong> : <em>bool</em><br /><em>Returns true if given number is even.</em> |
| public static | <strong>isFirstSliceOfSameType(</strong><em>int</em> <strong>$sliceId</strong>)</strong> : <em>bool</em><br /><em>Check if previous slice is from same module type. Useful in module outputs to create multi blocks.</em> |
| public static | <strong>isFrontend()</strong> : <em>bool</em><br /><em>Opposite of rexx::isBackend().</em> |
| public static | <strong>isLastSliceOfSameType(</strong><em>int</em> <strong>$sliceId</strong>)</strong> : <em>bool</em><br /><em>Check if next slice is from same module type. Useful in module outputs to create multi blocks.</em> |
| public static | <strong>isMediaValid(</strong><em>\rex_media</em> <strong>$media</strong>)</strong> : <em>bool</em><br /><em>Checks if media is valid.</em> |
| public static | <strong>isOdd(</strong><em>int</em> <strong>$number</strong>)</strong> : <em>bool</em><br /><em>Returns true if given number is odd.</em> |
| public static | <strong>isSiteStartArticle()</strong> : <em>bool</em><br /><em>Checks if the current article is the site start article.</em> |
| public static | <strong>isSliceValid(</strong><em>\rex_article_slice</em> <strong>$slice</strong>)</strong> : <em>bool</em><br /><em>Returns true if given slice is valid.</em> |
| public static | <strong>isSubDirInstall()</strong> : <em>bool</em><br /><em>Returns true if redaxo is installed in subdir.</em> |
| public static | <strong>isUrlValid(</strong><em>string</em> <strong>$url</strong>)</strong> : <em>bool</em><br /><em>Checks if given url is available by the used rewriter. Must be called in PACKAGE_INCLUDED or later!</em> |
| public static | <strong>prettyPrintVar(</strong><em>string</em> <strong>$varTitle</strong>, <em>string</em> <strong>$varValue</strong>, <em>string</em> <strong>$icon=`'fa-info-circle'`</strong>)</strong> : <em>string</em><br /><em>Returns a html box for a key/value pair data. Useful for module output in backend.</em> |
| public static | <strong>redirect(</strong><em>string[]</em> <strong>$url</strong>, <em>int</em> <strong>$statusCode=301</strong>)</strong> : <em>void</em><br /><em>Redirects to given url with default 301 status code. Wrapper for rexx::redirectToUrl();</em> |
| public static | <strong>redirectToArticle(</strong><em>int</em> <strong>$id</strong>, <em>int</em> <strong>$clang=null</strong>, <em>array/string[]</em> <strong>$params=array()</strong>, <em>int</em> <strong>$statusCode=301</strong>)</strong> : <em>void</em><br /><em>Redirects to given article with default 301 status code.</em> |
| public static | <strong>redirectToUrl(</strong><em>string[]</em> <strong>$url</strong>, <em>int</em> <strong>$statusCode=301</strong>)</strong> : <em>void</em><br /><em>Redirects to given url with default 301 status code.</em> |
| public static | <strong>removeDirRecursively(</strong><em>string</em> <strong>$dir=null</strong>, <em>bool</em> <strong>$securitySwitch=false</strong>)</strong> : <em>void</em><br /><em>Removes all subdirs and files recursively. Keep $securitySwitch = false first to see the path you will delete first in exception! Be careful with this!</em> |
| public static | <strong>setGlobalLangPreset(</strong><em>array/string[]</em> <strong>$specialChars=array()</strong>, <em>array/string[]</em> <strong>$specialCharsRewrite=array()</strong>)</strong> : <em>void</em><br /><em>Sets the global preset. Can be used in boot.php of project addon.</em> |
| public static | <strong>setLangPreset(</strong><em>string</em> <strong>$originalName</strong>, <em>string</em> <strong>$code</strong>, <em>string</em> <strong>$regionCode</strong>, <em>string</em> <strong>$urlSlug</strong>, <em>string</em> <strong>$hreflang</strong>, <em>string</em> <strong>$dir</strong>, <em>string[]</em> <strong>$specialChars</strong>, <em>string[]</em> <strong>$specialCharsRewrite</strong>)</strong> : <em>void</em><br /><em>Modifys a lang preset that already exists. Can be used in boot.php of project addon to modify the existing presets.</em> |
| public static | <strong>setLocale(</strong><em>string</em> <strong>$regionCode=`''`</strong>)</strong> : <em>void</em><br /><em>Sets the global locale for php. Then all php strings like month names are in the desired language, use strftime(). X-Core calls this automatically.</em> |
| public static | <strong>stringContains(</strong><em>string</em> <strong>$haystack</strong>, <em>string</em> <strong>$needle</strong>)</strong> : <em>bool</em><br /><em>Checks if $haystack contains $needle.</em> |
| public static | <strong>stringEndsWith(</strong><em>string</em> <strong>$haystack</strong>, <em>string</em> <strong>$needle</strong>)</strong> : <em>bool</em><br /><em>Checks if $haystack ends with $needle.</em> |
| public static | <strong>stringStartsWith(</strong><em>string</em> <strong>$haystack</strong>, <em>string</em> <strong>$needle</strong>)</strong> : <em>bool</em><br /><em>Checks if $haystack starts with $needle.</em> |
| protected static | <strong>isSliceOfSameType(</strong><em>int</em> <strong>$sliceId</strong>, <em>bool</em> <strong>$previous=true</strong>)</strong> : <em>bool</em><br /><em>Helper for isFirstSliceOfSameType() and isLastSliceOfSameType().</em> |

*This class extends \rex*

